
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace CheeseBreakout
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        ContentManager content;

        int cheeseX = 0;
        int cheeseY = 0;

        int breadX;
        int breadY;

        int padXSpeed = 10;
        int padYSpeed = 10;

        int cheeseXSpeed = 1;
        int cheeseYSpeed = 1;

        /// <summary>
        /// The texture which represents our cheese
        /// </summary>
        Texture2D cheeseTexture;

        /// <summary>
        /// The texture which represents our bread
        /// </summary>
        Texture2D breadTexture;

        /// <summary>
        /// A batch of sprites for a single drawing action
        /// </summary>
        SpriteBatch spriteBatch;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            content = new ContentManager(Services);
        }


        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }


        /// <summary>
        /// Load your graphics content.  If loadAllContent is true, you should
        /// load content from both ResourceManagementMode pools.  Otherwise, just
        /// load ResourceManagementMode.Manual content.
        /// </summary>
        /// <param name="loadAllContent">Which type of content to load.</param>
        protected override void LoadGraphicsContent(bool loadAllContent)
        {
            if (loadAllContent)
            {
                cheeseTexture = content.Load<Texture2D>(@"Content\Textures\cheese");
                breadTexture = content.Load<Texture2D>(@"Content\Textures\bread");
                spriteBatch = new SpriteBatch(graphics.GraphicsDevice);
            }

            // TODO: Load any ResourceManagementMode.Manual content
        }


        /// <summary>
        /// Unload your graphics content.  If unloadAllContent is true, you should
        /// unload content from both ResourceManagementMode pools.  Otherwise, just
        /// unload ResourceManagementMode.Manual content.  Manual content will get
        /// Disposed by the GraphicsDevice during a Reset.
        /// </summary>
        /// <param name="unloadAllContent">Which type of content to unload.</param>
        protected override void UnloadGraphicsContent(bool unloadAllContent)
        {
            if (unloadAllContent == true)
            {
                content.Unload();
            }
        }


        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the default game to exit on Xbox 360 and Windows
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            cheeseX = cheeseX + cheeseXSpeed;

            if ((cheeseX <= 0) ||
                (cheeseX + cheeseTexture.Width > Window.ClientBounds.Width))
            {
                cheeseXSpeed *= -1;
            }

            cheeseY = cheeseY + cheeseYSpeed;

            if ((cheeseY <= 0) ||
                (cheeseY + cheeseTexture.Height > Window.ClientBounds.Height))
            {
                cheeseYSpeed *= -1;
            }

            GamePadState padState = GamePad.GetState(PlayerIndex.One);

            if (padState.IsConnected)
            {
                breadX += (int)(padState.ThumbSticks.Left.X * padXSpeed);
                breadY -= (int)(padState.ThumbSticks.Left.Y * padYSpeed);
            }

            base.Update(gameTime);
        }


        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin(SpriteBlendMode.AlphaBlend);

            spriteBatch.Draw(cheeseTexture,
                new Rectangle(cheeseX, cheeseY, cheeseTexture.Width, cheeseTexture.Height), Color.White);

            spriteBatch.Draw(breadTexture,
                new Rectangle(breadX, breadY, breadTexture.Width, breadTexture.Height), Color.White);

            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}